//Essa unit e bastante extensa mas simples, e com muitas partes
//repetidas. Nao acredito que seja necessario comentar trechos dessa unit, o que
//pode gerar alguma dificuldade de entendimento nao eh um trecho especifico de
//codigo, mas um entendimento geral do funcionamento da unit. Saber como  o
//fluxo de informacoes, ...
//Para isso sugiro a leitura do capitulo XX do livro XX. Foi de la que tirei o
//modelo para esse leitor. Tive que alterar algumas coisas, pois o nosso leitor
//eh um pouco mais completo. Mas para o entendimento essa leitura eh excelente.

//O leitor funciona, mas nao esta muito robusto. Caso o arquivo fuja um pouqinho do
//padrao, PAUUUU.
//Tem uma coisa faltando que me recordo, eh a repetida insercao de dos inserts em
//forma de grade. Consequencia do tratamento dos grupos XX e XX da entidade Insert.
//Acho que uma boa solucao eum pre-processamento, criando todos os inserts que
//formariam a grade e inseri-los na lista. Fazendo isso nao eh preciso mexer no
//exibidor de inserts.

//Qualquer duvida entrar em contato com:

// Marcelo Braun -> mbraun@ez-poa.com.br
// Silton Sommer -> silton@pucrs.br
// Andre Antoniazzi -> andre@netsul.com.br

unit UDXF;

interface

uses Classes;

type

	TPonto3D = class
	x, y, z: real;
	end;

	TCor = class
	R, G, B: real;
	end;

	TCamada = class
  	Nome: string;
        Cor: TCor;
        end;

        TEntidade = class
  	Camada: string;
        Cor: TCor;
        end;

	TFace3D = class (TEntidade)
  	Camada: string;
	Vertices: TList;// Lista de TPonto3D
	Flag: integer;
	end;

        TLinha = class (TEntidade)
  	Camada: string;
  	Inicio, Fim: TPonto3D;
        end;

        TArco = class (TEntidade)
  	Centro: TPonto3D;
        Raio, AngINI, AngFIM: Real;
        end;

        TCirculo = class (TEntidade)
  	Centro: TPonto3D;
        Raio: Real;
        end;

        TVertice = class (TEntidade)
  	Flag: integer;
        Coord: TPonto3D;
        end;

        TFace = class (TEntidade)
  	Fst, Snd, Trd, Fth: integer;	//Indices para a lista de vertices da entidade												//PolyLine. Indicam quais os elementos da lis-
        end;                         //ta que compoem a face

        TPolyLine = class (TEntidade)
  	M, N, MSuave, NSuave: integer;
        Flag, Follow: integer;
        Elevacao: real;
  	Vertices,						//Lista de TPonto3D
        Faces: TList;				//Lista de TFace
        end;

        TBloco = class (TEntidade)
  	Nome: string;
  	Flag: integer;
        Posicao: TPonto3D;
	BLFace3D, BLLinha, BLArco, BLCirculo, BLPolyLine, BLInsert: TList;
        end;

        TInsert = class (TEntidade)
  	NomeBloco: string;
        PtInsercao, 	//Coordenada onde o bloco ser inserido
        UpDir: TPonto3D;
        EscalaX, EscalaY, EscalaZ,
        Pitch, Roll, Yaw,
        AngRotacao: Real;             //Angulo de Rotaco em torno do eixo UpDir;
        NumCol, NumLin,               //Numero de insercoes na direcao da col e lin
        EspCol, EspLin: integer;			//Espacamento entre as insercoes
        end;

        TEscritor = class
        Xini_r, Yini_r, Zini_r,
        Vbaixa_r, Vmedia_r, Valta_r:real;
        Angulo_i, Altura_i:integer;
        end;

  function DXFEscritor  (NomeArquivo: string; Valores: TEscritor) :boolean;
  function DXFLeitor   (NomeArquivo: string) :boolean;

  procedure InformaLimites(Var MinX, MinY, MinZ, MaxX, MaxY, MaxZ:real);

var

  //Listas com as entidades
  LFace3D, LLinha, LArco, LCirculo, LPolyLine, LBloco, LInsert, LCamada: TList;

implementation
uses SysUtils, Dialogs;

const ctNovoArquivo='NewflDxf.txt';
const ctFLOAT='FLOAT';
const ctINTEGER='INTEGER';
 
var

  //filepointer
  fp,fpc: TextFile;
  //guardam as dimensoes do maximas e minimas do cenario
  XMin, XMax, YMin, YMax, ZMin, ZMax: Real;
  //posicao inicial dentro do cenario (x,y,z)
  XIni_r, YIni_r, ZIni_r,
  //valores das velocidades
  VBaixa_r, VMedia_r, VAlta_r,
  //altura do avatar
  Altura_r: Real;
  Angulo_i, Altura_i:integer;

//***********************************************************//
//***********************************************************//
//            R O T I N A S  A U X I L I A R E S             //
//***********************************************************//
//***********************************************************//

//***********************************************************//
//	Data: __/__/____   Autor: ____________________       //
//	Descrio:                                           //
//***********************************************************//
function ConverteDecimal(numero:real): string;
var
   straux: string;
   i: integer;
begin
   i:=1;
   straux:=FormatFloat('0.00',numero);
   while (straux[i] <> '') do
   begin
       if (straux[i] = ',')
       then
           begin
                straux[i] := '.';
                break;
                end;
       i:=i+1;
   end;
   result:=straux;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: Utilizado para salvar as configuracoes iniciais definidas
//  na tela inicial. Escreve grupos do DXF em comentario                                               //
//***********************************************************//

function DXFEscreveGrupo(Palavra: string; Valor: real; Tipo:string) :boolean;
begin
   Writeln(fp,'999');
   Writeln(fp,Palavra);
   Writeln(fp,'999');
   if Tipo = ctFLOAT
      then Writeln(fp,ConverteDecimal(Valor))
      else Writeln(fp,round(Valor));
   Result:= True;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: Le um grupo do arquivo dxf (2 linhas)                                              //
//***********************************************************//

function DXFLeGrupo (var Codigo:integer; var Palavra:string) :boolean;
begin
     Readln(fp,Codigo);
     Readln(fp,Palavra);
     Result:= True;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: le um valor inteiro                                              //
//***********************************************************//

function DXFLeInteiro (var Codigo: integer) :boolean;
begin
     Readln(fp,Codigo);
     Result:= TRUE;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeReal (var Valor: Real) :boolean;
begin
     Readln(fp,Valor);
     Result:= TRUE;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLePalavra (var Palavra: string) :boolean;
begin
     Readln(fp,Palavra);
     Result:= TRUE;
end;

procedure InformaLimites(Var MinX, MinY, MinZ, MaxX, MaxY, MaxZ:real);
begin
     MinX:= XMin;
     MinY:= YMin;
     MinZ:= ZMin;
     MaxX:= XMax;
     MaxY:= YMax;
     MaxZ:= ZMax;
end;
//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeXYZ (var Vertice: TPonto3D):boolean;
var
   cod: integer;
   aux: TPonto3D;
begin
   aux:= TPonto3D.Create;
   Readln(fp,aux.x);
   if (aux.x<XMin)
      then XMin:= aux.x;
   if (aux.x>XMax)
      then XMax:= aux.x;
   Readln(fp,cod);
   if ((cod<>20) or (cod<>21) or (cod<>22) or (cod<>23))
      then Result:= False;
   Readln(fp,aux.y);
   if (aux.y<YMin)
      then YMin:= aux.y;
   if (aux.y>YMax)
      then YMax:= aux.y;
   Readln(fp,cod);
   if ((cod<>30) or (cod<>31) or (cod<>32) or (cod<>33))
      then Result:= False;
   Readln(fp,aux.z);
   if (aux.z<ZMin)
      then ZMin:= aux.z;
   if (aux.z>ZMax)
      then ZMax:= aux.z;
   Vertice:= aux;
   Result:= True;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFPulaTabela :boolean;
var
   Codigo: integer;
   Palavra: string;
begin
     DXFLeGrupo(Codigo, Palavra);
     while ((Codigo<>0) or (Palavra<>'ENDTAB')) do
     begin
  	DXFLeGrupo(Codigo, Palavra);
     end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFPulaSecao :boolean;
var
   Codigo: integer;
   Palavra: string;
begin
     DXFLeGrupo(Codigo, Palavra);
     while ((Codigo<>0) or (Palavra<>'ENDSEC')) do
     begin
          DXFLeGrupo(Codigo, Palavra);
     end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function Indice2RGB (Indice: integer) :TCor;
var
   Cor: TCor;
   P: real;
begin
     Cor:= TCor.Create;
     with Cor do
     begin
          R:=1;
          G:=1;
          B:=0;
     case Indice of
          1: begin
	          R:=1; G:=0; B:=0;
             end;
	  2: begin
  	          R:=1; G:=1; B:=0;
             end;
	  3: begin
                  R:=0; G:=1; B:=0;
             end;
	  4: begin
                  R:=0; G:=1; B:=1;
             end;
	  5: begin
                  R:=0; G:=0; B:=1;
             end;
	  6: begin
                  R:=1; G:=0; B:=1;
             end;
	  7: begin
                  R:=1; G:=1; B:=1;
             end;
	  10..49: begin //Vemelho . Amarelo
		        P:= ((Indice-10)/40);
                        R:= 1*(1-P) + 1*P;
                        G:= 0+1*P;
                        B:= 0;
                  end;
          50..89: begin //Amarelo . Verde
		        P:= ((Indice-50)/40);
                        R:= 1*(1-P) + 0;
                        G:= 1+1*P;
                        B:= 0;
      		  end;
          90..129: begin //Verde . Ciano
		         P:= ((Indice-90)/40);
	                 R:= 0;
	                 G:= 1*(1-P)+1*P;
	                 B:= 0 + 1*P;
	      	   end;
          130..169: begin //Ciano . Azul
		          P:= ((Indice-130)/40);
	                  R:= 0;
	                  G:= 1*(1-P) + 0;
	                  B:= 1*(1-P) + 1*P;
                    end;
          170..209: begin //Azul  . Magenta
		          P:= ((Indice-170)/40);
	                  R:= 0+1*P;
	                  G:= 0;
	                  B:= 1*(1-P) + 1*P;
	      	    end;
          210..249: begin //Magenta . Vermelho
		          P:= ((Indice-210)/40);
	                  R:= 1*(1-P) + 1*P;
	                  G:= 0;
	                  B:= 1	+ 0 ;
	      	    end;
	  250..254: begin //Preto . Branco
		          P:= ((Indice-250)/5);
	                  R:= 0 + 1*P;
	                  G:= 0 + 1*P;
	                  B:= 0	+ 1*P;
	      	   end;
          255: begin
                    R:=256;
                    G:=256;
                    B:=256;
               end;
     end;//cor
  end;
  Result:= Cor;
//.
end;

//***********************************************************//
//***********************************************************//
//    R O T I N A S  L E I T O R A S  D A S  S E C O E S     //
//***********************************************************//
//***********************************************************//

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFCopiaArquivo(NomeArquivo: string; NovoArquivo: string): boolean;
var
   strLinAux: string;
begin
     AssignFile(fp, NomeArquivo);
     Rewrite(fp);

     AssignFile(fpc, NovoArquivo);
     Reset(fpc);

     Readln(fpc,strLinAux);
     while (strLinAux<>'EOF') do
     begin
          Writeln(fp, strLinAux);
          readln(fpc, strLinAux);
     end;
     Writeln(fp,'EOF');
     Closefile(fp);
     Closefile(fpc);
     Erase(fpc);
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFEscritor(NomeArquivo: string; Valores: TEscritor) :boolean;
var
   strlinha: string;
begin
     AssignFile(fp, NomeArquivo);
     Reset(fp);

     Readln(fp,strlinha);
     while (strlinha<>'EOF') do
           Readln(fp,strlinha);

  {-- Realiza a escrita dos Valores para o arquivo --}
     if  (not eof(fp))
     then //entAo inicia o processo de copia
     begin
          CloseFile(fp);
          if RenameFile(NomeArquivo,ctNovoArquivo) = False
             then ShowMessage('Ocorreu problemas ao RENOMEAR os Arquivos!');
          if DXFCopiaArquivo(NomeArquivo,ctNovoArquivo) = False
             then ShowMessage('Ocorreu problemas ao COPIAR Arquivos!');
     end
     else CloseFile(fp);

  {-- Escrevo as informacoes da tela para o arquivo --}
  AssignFile(fp, NomeArquivo);
  Append(fp);
  Writeln(fp,999);
  Writeln(fp,'CONFIG');
  DXFEscreveGrupo('XINI',Valores.Xini_r,ctFLOAT);
  DXFEscreveGrupo('YINI',Valores.Yini_r,ctFLOAT);
  DXFEscreveGrupo('ZINI',Valores.Zini_r,ctFLOAT);
  DXFEscreveGrupo('VBAIXA',Valores.Vbaixa_r,ctFLOAT);
  DXFEscreveGrupo('VMEDIA',Valores.Vmedia_r,ctFLOAT);
  DXFEscreveGrupo('VALTA',Valores.Valta_r,ctFLOAT);
  DXFEscreveGrupo('ALTURA',Valores.Altura_i,ctINTEGER);
  DXFEscreveGrupo('ANGULO',Valores.Angulo_i,ctINTEGER);
  CloseFile(fp);
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

procedure DXFLeConfig;// boolean;
var
   Codigo: integer;
   Palavra: string;
   RetVal: boolean;
begin
   RetVal:= DXFLeGrupo(Codigo, Palavra);
   while (not eof(fp)) do
   begin
   if (Palavra='XINI')
      then
      begin
           DXFLeInteiro(Codigo);
    	   DXFLeReal(XINI_r);
      end;

   if (Palavra='YINI')
      then
      begin
           DXFLeInteiro(Codigo);
    	   DXFLeReal(YINI_r);
      end;

  if (Palavra='ZINI')
     then
     begin
          DXFLeInteiro(Codigo);
    	  DXFLeReal(ZINI_r);
     end;

  if (Palavra='VBAIXA')
     then
     begin
          DXFLeInteiro(Codigo);
    	  DXFLeReal(VBaixa_r);
     end;

  if (Palavra='VMEDIA')
     then
     begin
          DXFLeInteiro(Codigo);
    	  DXFLeReal(VMedia_r);
     end;

  if (Palavra='VALTA')
     then
     begin
          DXFLeInteiro(Codigo);
    	  DXFLeReal(VAlta_r);
     end;

  if (Palavra='ALTURA')
     then
     begin
          DXFLeInteiro(Codigo);
          DXFLeInteiro(Altura_i);
     end;

  if (Palavra='ANGULO')
     then
     begin
          DXFLeInteiro(Codigo);
    	  DXFLeInteiro(Angulo_i);
     end;

  DXFLeGrupo(Codigo, Palavra);
  end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeLayer :boolean;
var
   RetVal: boolean;
   Codigo, IndiceCor: integer;
   Palavra, Lixo: string;
   Camada: TCamada;
begin
     DXFLeGrupo(Codigo,Palavra);
     while (Codigo<>0) do	//Pula o cabecalho da Tabela
           DXFLeGrupo(Codigo,Palavra);
           Camada:= TCamada.Create;
     while (RetVal and (Palavra<>'ENDTAB')) do
     begin
     if (Palavra<>'LAYER')
        then
        begin
    	     result:= False;
    	     exit;
        end;
     DXFLeInteiro(Codigo);
     while (Codigo<>0) do
     begin
          case (Codigo) of
	  2: begin
                  DXFLePalavra(Camada.Nome);
                  DXFLeInteiro(Codigo);
             end;

          62: begin
        		DXFLeInteiro(IndiceCor);
            Camada.Cor:= Indice2RGB(IndiceCor);
        		DXFLeInteiro(Codigo);
            end;

				else begin
      		DXFLePalavra(Lixo);
       		DXFLeInteiro(Codigo);
				end;
      end;
    end;

		LCamada.Add(Camada);
		Camada:= TCamada.Create;
		DXFLePalavra(Palavra);
  end;

	Result:= True;

end;


//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeTables :boolean;
var
   RetVal: boolean;
   Codigo: integer;
   Palavra: string;
begin
   RetVal:= DXFLeGrupo(Codigo, Palavra);
   while (RetVal and (Palavra<>'ENDSEC')) do
   begin
        if (Palavra='TABLE')
           then
           begin
	        DXFLeGrupo(Codigo, Palavra);
           if (Palavra='LAYER')
              then DXFLeLayer
              else DXFPulaTabela;
           end;
   RetVal:= DXFLeGrupo(Codigo, Palavra);
  end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeEndBlk: boolean;
var
	Codigo: integer;
  Lixo: string;
  RetVal: boolean;
begin
	RetVal:= DXFLeInteiro(Codigo);
  while (RetVal and (Codigo<>0)) do
  begin
	  case (Codigo) of
			 8: begin
						DXFLePalavra(Lixo);
						RetVal:= DXFLeInteiro(Codigo);
					end;

			else begin
					DXFLePalavra(Lixo);
					RetVal:= DXFLeInteiro(Codigo);
					end;
		end;
  end;
end;


//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFIgnoraEntidade :boolean;
var
	Codigo: integer;
  Lixo: string;
  RetVal: boolean;
begin

	RetVal:= DXFLeInteiro(Codigo);
  while (RetVal and (Codigo<>0)) do
  begin
  	DXFLePalavra(Lixo);
    DXFLeInteiro(Codigo);
  end;
  Result:= True;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeFace3D (var L: TList) :boolean;
var
	Face: TFace3D;
	Vertice: TPonto3D;
	RetVal: boolean;
	IndiceCor, Codigo: integer;
	Lixo: string;

begin
	Result:= False;
	Face:= TFace3D.Create;
	Face.Vertices:= TList.Create;
	Vertice:= TPonto3D.Create;
	IndiceCor:= 0;

	RetVal:= DXFLeInteiro(Codigo);
	while (RetVal and (Codigo<>0)) do
	begin

		case (Codigo) of
			 8: begin
					RetVal:= DXFLePalavra(Face.Camada);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			62: begin
					DXFLeInteiro(IndiceCor);
					Face.Cor:= Indice2RGB(IndiceCor);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			10..13: begin										//Le as coordenadas x, y e z de cada
					DXFLeXYZ(Vertice);					//um dos vertices que compoem a face
					Face.Vertices.Add(Vertice);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			else begin
					DXFLePalavra(Lixo);
					DXFLeInteiro(Codigo);
					end;
  	end;

	end;

	L.Add(Face);
	Result:= True;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeLinha (var L: TList) :boolean;
var
	RetVal: Boolean;
	Codigo, IndiceCor: integer;
  Lixo: string;
  Linha: TLinha;
begin
	Result:= False;

  Linha:= TLinha.Create;
  RetVal:= DXFLeInteiro(Codigo);

	while (RetVal and (Codigo<>0)) do
	begin

		case (Codigo) of
			 8: begin
					RetVal:= DXFLePalavra(Linha.Camada);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			62: begin
					DXFLeInteiro(IndiceCor);
					Linha.Cor:= Indice2RGB(IndiceCor);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			10: begin										//Le as coordenadas x, y e z do
					DXFLeXYZ(Linha.Inicio); //ponto inicial da linha
					RetVal:= DXFLeInteiro(Codigo);
					end;

			11: begin										//Le as coordenadas x, y e z do
					DXFLeXYZ(Linha.Fim);	  //ponto final da linha
					RetVal:= DXFLeInteiro(Codigo);
					end;

			else begin
					DXFLePalavra(Lixo);
					DXFLeInteiro(Codigo);
					end;
    end;

  end;

  L.Add(Linha);
  Result:= True;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeArco (var L: TList) :boolean;
var
	RetVal: Boolean;
	Codigo, IndiceCor: integer;
  Lixo: string;
  Arco: TArco;
begin
	Result:= False;

  Arco:= TArco.Create;
  RetVal:= DXFLeInteiro(Codigo);

	while (RetVal and (Codigo<>0)) do
	begin

		case (Codigo) of
			 8: begin
					RetVal:= DXFLePalavra(Arco.Camada);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			62: begin
					DXFLeInteiro(IndiceCor);
					Arco.Cor:= Indice2RGB(IndiceCor);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			10: begin										//Le as coordenadas x, y e z do
					DXFLeXYZ(Arco.Centro); 	//centro do arco
					RetVal:= DXFLeInteiro(Codigo);
					end;

			40: begin
          DXFLeReal(Arco.Raio);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			50: begin
          DXFLeReal(Arco.AngINI);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			51: begin
          DXFLeReal(Arco.AngFIM);
					RetVal:= DXFLeInteiro(Codigo);
					end;


			else begin
					DXFLePalavra(Lixo);
					DXFLeInteiro(Codigo);
					end;
		end;

  end;

  L.Add(Arco);
  Result:= True;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeCirculo (var L: TList) :boolean;
var
	RetVal: Boolean;
	Codigo, IndiceCor: integer;
  Lixo: string;
  Circulo: TCirculo;
begin
	Result:= False;

  Circulo:= TCirculo.Create;
  RetVal:= DXFLeInteiro(Codigo);

	while (RetVal and (Codigo<>0)) do
	begin

		case (Codigo) of
			 8: begin
					RetVal:= DXFLePalavra(Circulo.Camada);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			62: begin
					DXFLeInteiro(IndiceCor);
					Circulo.Cor:= Indice2RGB(IndiceCor);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			10: begin											//Le as coordenadas x, y e z do
					DXFLeXYZ(Circulo.Centro); //centro do circulo
					RetVal:= DXFLeInteiro(Codigo);
					end;

			40: begin
          DXFLeReal(Circulo.Raio);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			else begin
					DXFLePalavra(Lixo);
					DXFLeInteiro(Codigo);
					end;
		end;

  end;

  L.Add(Circulo);
  Result:= True;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

procedure DXFLeCabecalhoPolyLine (var PolyLine: TPolyLine);
var
	Codigo, IndiceCor: Integer;
  RetVal: Boolean;
  Lixo: string;
  PontoElev: TPonto3D;
begin

	PontoElev:= TPonto3D.Create;

  RetVal:= DXFLeInteiro(Codigo);
	while (RetVal and (Codigo<>0)) do
	begin

		case (Codigo) of
			 8: begin
					RetVal:= DXFLePalavra(PolyLine.Camada);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			62: begin
					DXFLeInteiro(IndiceCor);
					PolyLine.Cor:= Indice2RGB(IndiceCor);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			10: begin
					DXFLeXYZ(PontoElev);
          PolyLine.Elevacao:= PontoElev.z;
					RetVal:= DXFLeInteiro(Codigo);
					end;

			66: begin
          DXFLeInteiro(PolyLine.Follow);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			70: begin
          DXFLeInteiro(PolyLine.Flag);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			71: begin
          DXFLeInteiro(PolyLine.M);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			72: begin
          DXFLeInteiro(PolyLine.N);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			73: begin
          DXFLeInteiro(PolyLine.MSuave);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			74: begin
          DXFLeInteiro(PolyLine.NSuave);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			else begin
					DXFLePalavra(Lixo);
					DXFLeInteiro(Codigo);
					end;
		end;

  end;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeSeqEnd: boolean;
var
	Codigo: integer;
  Lixo: string;
  RetVal: boolean;
begin
	RetVal:= DXFLeInteiro(Codigo);
  while (RetVal and (Codigo<>0)) do
  begin
	  case (Codigo) of
			 8: begin
						DXFLePalavra(Lixo);
						RetVal:= DXFLeInteiro(Codigo);
					end;

			else begin
					DXFLePalavra(Lixo);
					RetVal:= DXFLeInteiro(Codigo);
					end;
		end;
  end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeListaVertices(var PolyLine:TPolyLine): boolean;
var
	Palavra, Lixo: string;
  Codigo, IndiceCor: integer;
  RetVal, IsFace: boolean;
  VerticeAUX: TVertice;
  FaceAUX: TFace;

begin

	PolyLine.Vertices:= TList.Create;
	PolyLine.Faces:= TList.Create;

  RetVal:= DXFLePalavra(Palavra);
  while (RetVal and (Palavra<>'SEQEND')) do
  begin
  	if (Palavra<>'VERTEX') then
    begin
      result:= False;
      exit;
    end;

		VerticeAUX:= TVertice.Create;
    FaceAUX:= TFace.Create;
    IsFace:= False;

    DXFLeInteiro(Codigo);
    while (Codigo<>0) do
    begin
      case (Codigo) of
				 8: begin
						RetVal:= DXFLePalavra(VerticeAUX.Camada);
						RetVal:= DXFLeInteiro(Codigo);
						end;

				62: begin
						DXFLeInteiro(IndiceCor);
						VerticeAUX.Cor:= Indice2RGB(IndiceCor);
						RetVal:= DXFLeInteiro(Codigo);
						end;

				10: begin
						DXFLeXYZ(VerticeAUX.Coord);
						RetVal:= DXFLeInteiro(Codigo);
						end;

				71: begin
            IsFace:= True;
						DXFLeInteiro(FaceAUX.Fst);
						RetVal:= DXFLeInteiro(Codigo);
						end;

				72: begin
            IsFace:= True;
						DXFLeInteiro(FaceAUX.Snd);
						RetVal:= DXFLeInteiro(Codigo);
						end;

				73: begin
            IsFace:= True;
						DXFLeInteiro(FaceAUX.Trd);
						RetVal:= DXFLeInteiro(Codigo);
						end;

				74: begin
            IsFace:= True;
						DXFLeInteiro(FaceAUX.Fth);
						RetVal:= DXFLeInteiro(Codigo);
						end;

				else begin
						DXFLePalavra(Lixo);
						DXFLeInteiro(Codigo);
						end;
	    end;
    end;

    //Insere a entidade na respectiva lista,
    //e destroi o objeto que nao foi usado
    if (IsFace) then
    begin
    	PolyLine.Faces.Add(FaceAUX);
//      VerticeAUX.Free;
    end else
    begin
    	PolyLine.Vertices.Add(VerticeAUX);
//      FaceAUX.Free;
    end;

    DXFLePalavra(Palavra);

  end;

  if (Palavra='SEQEND') then DXFLeSeqEnd;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLePolyLine (var L: TList) :boolean;
var
	IsFace: Boolean;
  PolyLine: TPolyLine;

begin
	Result:= False;

  PolyLine:= TPolyLine.Create;

  DXFLeCabecalhoPolyLine(PolyLine);
  DXFLeListaVertices(PolyLine);


  L.Add(PolyLine);
  Result:= True;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeBlock :boolean;
var
	Codigo, IndiceCor: integer;
  Palavra, Lixo: string;
  RetVal: boolean;
  Bloco: TBloco;
begin
	Bloco:= TBloco.Create;

	RetVal:= DXFLeInteiro(Codigo);
  while (RetVal and (Codigo<>0)) do
	begin

		case (Codigo) of
    2..3: begin
          DXFLePalavra(Bloco.Nome);
          RetVal:= DXFLeInteiro(Codigo);
    			end;

			 8: begin
					DXFLePalavra(Bloco.Camada);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			62: begin
					DXFLeInteiro(IndiceCor);
					Bloco.Cor:= Indice2RGB(IndiceCor);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			10: begin
					DXFLeXYZ(Bloco.Posicao);
					RetVal:= DXFLeInteiro(Codigo);
					end;

      70:	begin
      		DXFLeInteiro(Bloco.Flag);
          DXFLeInteiro(Codigo);
      		end;

			else begin
					DXFLePalavra(Lixo);
					DXFLeInteiro(Codigo);
					end;
  	end;

	end;
  Bloco.BLLinha:= TList.Create;
  Bloco.BLFace3D:= TList.Create;
  Bloco.BLArco:= TList.Create;
  Bloco.BLCirculo:= TList.Create;
  Bloco.BLPolyLine:= TList.Create;

  RetVal:= DXFLePalavra(Palavra);
  while (RetVal and (Palavra<>'ENDBLK')) do
  begin
  	if (codigo=0) and (Palavra='LINE') then
    	DXFLeLinha(Bloco.BLLinha)
    else if (codigo=0) and (Palavra='3DFACE') then
    	DXFLeFace3D(Bloco.BLFace3D)
    else if (codigo=0) and (Palavra='ARC') then
    	DXFLeArco(Bloco.BLArco)
    else if (codigo=0) and (Palavra='CIRCLE') then
    	DXFLeCirculo(Bloco.BLCirculo)
    else if (codigo=0) and (Palavra='POLYLINE') then
    	DXFLePolyLine(Bloco.BLPolyLine)
    else
    	DXFIgnoraEntidade;
    RetVal:= DXFLePalavra(Palavra);
  end;
  DXFLeEndBlk;
  LBloco.Add(Bloco);
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeBlocks :boolean;
var
	Codigo: integer;
  Palavra: string;
  RetVal: boolean;
begin

	RetVal:= DXFLeGrupo(Codigo, Palavra);
  while (RetVal and (Palavra<>'ENDSEC')) do
  begin
  	if (Palavra<>'BLOCK') then
    begin
    	result:= false;
      exit;
    end;
  	DXFLeBlock;
    RetVal:= DXFLePalavra(Palavra);
  end;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeInsert (var L: TList):boolean;
var
	Codigo, IndiceCor: integer;
  RetVal: boolean;
  Palavra, Lixo: string;
  Insert: TInsert;
begin
	Insert:= TInsert.Create;
	Insert.EscalaX:=1;
  Insert.EscalaY:=1;
  Insert.EscalaZ:=1;
	RetVal:= DXFLeInteiro(Codigo);
	while (RetVal and (Codigo<>0)) do
	begin

		case (Codigo) of
			 2: begin
					RetVal:= DXFLePalavra(Insert.NomeBloco);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			 8: begin
					RetVal:= DXFLePalavra(Insert.Camada);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			10..13: begin
					DXFLeXYZ(Insert.PtInsercao);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			41: begin
					DXFLeReal(Insert.EscalaX);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			42: begin
					DXFLeReal(Insert.EscalaY);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			43: begin
					DXFLeReal(Insert.EscalaZ);
					RetVal:= DXFLeInteiro(Codigo);
					end;

			50: begin
       		if (Insert.UpDir=nil) then
          begin
          	Insert.UpDir:= TPonto3D.Create;
            with Insert.UpDir do
            begin
            	x:=0;
              y:=0;
              z:=1;
            end;
          end;

      		DXFLeReal(Insert.AngRotacao);
          RetVal:= DXFLeInteiro(Codigo);
      		end;

			62: begin
					DXFLeInteiro(IndiceCor);
					Insert.Cor:= Indice2RGB(IndiceCor);
					RetVal:= DXFLeInteiro(Codigo);
					end;

      70: begin
      		DXFLeInteiro(Insert.NumCol);
					RetVal:= DXFLeInteiro(Codigo);
      		end;

      71: begin
      		DXFLeInteiro(Insert.NumLin);
					RetVal:= DXFLeInteiro(Codigo);
      		end;

      44: begin
      		DXFLeInteiro(Insert.EspCol);
					RetVal:= DXFLeInteiro(Codigo);
      		end;

      45: begin
      		DXFLeInteiro(Insert.EspLin);
					RetVal:= DXFLeInteiro(Codigo);
      		end;

     210: begin
      		if (Insert.UpDir=nil) then
          	Insert.UpDir:= TPonto3D.Create;

      		DXFLeReal(Insert.UpDir.x);
					RetVal:= DXFLeInteiro(Codigo);
      		end;

     220: begin
      		if (Insert.UpDir=nil) then
          	Insert.UpDir:= TPonto3D.Create;

      		DXFLeReal(Insert.UpDir.y);
					RetVal:= DXFLeInteiro(Codigo);
      		end;

     230: begin
      		if (Insert.UpDir=nil) then
          	Insert.UpDir:= TPonto3D.Create;

      		DXFLeReal(Insert.UpDir.z);
					RetVal:= DXFLeInteiro(Codigo);
      		end;

			else begin
					DXFLePalavra(Lixo);
					DXFLeInteiro(Codigo);
					end;
  	end;

	end;

	L.Add(Insert);
	Result:= True;

end;


//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeEntities :boolean;
var
	RetVal: boolean;
	Codigo: integer;
	Palavra: string;
begin

	RetVal:= DXFLeGrupo(Codigo, Palavra);
	while (RetVal and (Palavra<>'ENDSEC')) do
	begin
		if (Palavra= 'INSERT') then	begin
			Result:= DXFLeInsert(LInsert);
			if Result= False then exit;
		end
                else if (Palavra= '3DFACE')
                     then begin
                             Result:= DXFLeFace3D(LFace3D);
                             if Result= False
                             then exit;
		          end
                     else if (Palavra= 'LINE')
                          then begin Result:= DXFLeLinha(LLinha);
                          if Result= False then exit;
		end else

		if (Palavra= 'ARC') then begin
			Result:= DXFLeArco(LArco);
      if Result= False then exit;
		end else

		if (Palavra= 'CIRCLE') then begin
			Result:= DXFLeCirculo(LCirculo);
      if Result= False then exit;
		end else

 		if (Palavra= 'POLYLINE') then begin
			Result:= DXFLePolyLine(LPolyLine);
      if Result= False then exit;
		end

		else begin
    	Result:= DXFIgnoraEntidade;
      if Result= False then exit;
		end;

		RetVal:= DXFLePalavra(Palavra);

	end;

end;


//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeSection :boolean;
var
   RetVal: boolean;
   Codigo: integer;
   Palavra: string;
begin
   RetVal:= DXFLeGrupo(Codigo, Palavra);
   if (Palavra='TABLES')
      then
      begin
           DXFLeTables;
      end else

   if (Palavra='BLOCKS')
      then
      begin
           DXFLeBlocks;
      end else

   if (Palavra='ENTITIES')
      then
      begin
           Result:= DXFLeEntities;
      if Result= False
         then exit;
      end

  else DXFPulaSecao;
end;


//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeArquivo :boolean;
var
   RetVal: boolean;
   Codigo: integer;
   Palavra: string;
begin
   RetVal:= DXFLeGrupo(Codigo, Palavra);
   while (RetVal and (Palavra<>'EOF')) do
   begin
   if (Palavra='SECTION')
      then DXFLeSection;
   RetVal:= DXFLeGrupo(Codigo, Palavra);
   end;

   if (eof(fp))
      then exit;
   DXFLeGrupo(Codigo, Palavra);
   if (Codigo=999) and (Palavra='CONFIG')
      then DXFLeConfig;

   Result:= TRUE;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function DXFLeitor (NomeArquivo: string) :boolean;
begin
     LFace3D:= TList.Create;
     LCamada:= TList.Create;
     LLinha:= TList.Create;
     LArco:= TList.Create;
     LCirculo:= TList.Create;
     LPolyLine:= TList.Create;
     LBloco:= TList.Create;
     LInsert:= TList.Create;

     XMin:= 50000;
     YMin:= 50000;
     ZMin:= 50000;
     XMax:= -50000;
     YMax:= -50000;
     ZMax:= -50000;

     AssignFile(fp, NomeArquivo);
     Reset(fp);

     DXFLeArquivo;

     CloseFile(fp);
end;
end.
